
#include "common.h"


__global__ void block2D_naive(float fac,float *A0,float *Anext, int nx, int ny, int nz)
{
	int i = blockIdx.x*blockDim.x+threadIdx.x;
    int j = blockIdx.y*blockDim.y+threadIdx.y;
	if( i>0 && j>0 &&(i<nx-1) &&(j<ny-1) )
	{
		for(int k=1;k<nz-1;k++)
		{
		__syncthreads();
		Anext[Index3D (nx, ny, i, j, k)] = 
		A0[Index3D (nx, ny, i, j, k + 1)] +
		A0[Index3D (nx, ny, i, j, k - 1)] +
		A0[Index3D (nx, ny, i, j + 1, k)] +
		A0[Index3D (nx, ny, i, j - 1, k)] +
		A0[Index3D (nx, ny, i + 1, j, k)] +
		A0[Index3D (nx, ny, i - 1, j, k)]
		- 6.0 * A0[Index3D (nx, ny, i, j, k)] / (fac*fac);
		}
	}
}

__global__ void block2D_opt_1(float fac,float *A0,float *Anext, int nx, int ny, int nz)
{
	//For optimization 1
}



__global__ void block2D_opt_2(float fac,float *A0,float *Anext, int nx, int ny, int nz)
{
	//For optimization 2
	
}

__global__ void block2D_opt_3(float fac,float *A0,float *Anext, int nx, int ny, int nz)
{
	//For optimization 3
}
